"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helper_1 = require("./helper");
/**
 * 劫持 VUE createElement 方法，注入样式绑定逻辑
 *
 * @export
 * @param {*} _this
 * @returns {*}
 */
function c(_this) {
    var args = Array.prototype.slice.call(arguments, 1);
    var fn = _this.createElement;
    var context = _this.context === void 0 ? {} : _this.context;
    var styles = _this.styles === void 0 ? context.$style || {} : _this.styles;
    if (helper_1.isString(styles)) {
        styles = context[styles] || {};
    }
    if (helper_1.isEmptyObject(styles)) {
        return fn.apply(null, args);
    }
    var classData = args[1];
    if (!helper_1.isObject(args[1])) {
        return fn.apply(null, args);
    }
    classData['staticClass'] = classData['staticClass'] ? classData['staticClass'] : '';
    classData['class'] = classData['class'] ? classData['class'] : '';
    classData['attrs'] = classData['attrs'] ? classData['attrs'] : '';
    var staticClasss = classData['staticClass'] || classData.attrs['staticClass'] || '';
    var classs = [];
    classs = handleObjectClass(classData['class']);
    handleAllClassData(staticClasss, classs, classData, styles);
    return fn.apply(null, args);
}
exports.default = c;
/**
 *  处理动态绑定class
 *
 * @param {*} objectClass
 * @returns {*}
 */
function handleObjectClass(objectClass) {
    var classes = [];
    if (helper_1.isString(objectClass) || Array.isArray(objectClass)) {
        classes = Array.isArray(objectClass) ? objectClass : [objectClass];
    }
    else if (helper_1.isObject(objectClass)) {
        for (var o in objectClass) {
            if (objectClass[o]) {
                classes.push(o);
            }
        }
        // classes.push('el-menu--horizontal');
    }
    else {
        classes = [];
    }
    return classes;
}
/**
 *  处理整体样式
 *
 * @param {*} staticClasss
 * @param {*} classs
 * @param {*} classData
 * @param {*} styles
 */
function handleAllClassData(staticClasss, classs, classData, styles) {
    if (staticClasss.length || classs.length) {
        var classArray = Array.isArray(staticClasss) ? staticClasss : [staticClasss];
        classArray = classArray.concat(classs);
        classData.staticClass = '';
        for (var i in classArray) {
            if (classArray[i] === void 0)
                continue;
            var classOne = classArray[i].split(/\s+/g);
            classOne.forEach(function (className) {
                if (styles[className.trim()]) {
                    classData.staticClass += " " + styles[className.trim()];
                }
                else {
                    classData.staticClass += " " + className;
                }
            });
        }
        classData.class = '';
    }
}
//# sourceMappingURL=c-elem.js.map